#ifndef _H_Canvas
#define _H_Canvas

#include <vector>

namespace mas {

class Rectangle;
class Point;
class Line;
class Color;

class Canvas {
public:
  virtual ~Canvas(){};

  virtual void DrawPolygon (const std::vector<Point>& p) = 0;
  virtual void DrawPolyline (const std::vector<Point>& p) = 0;
  virtual void DrawLine (const Line& z) = 0;
  virtual void DrawRectangle (const Rectangle& r) = 0;
  virtual void DrawEllipse (const Rectangle& r) = 0;
  virtual void DrawPoint (const Point& p) = 0;
  virtual void SetBrushColor (const Color& c) = 0;
};

}

#endif
