#ifndef _H_Figure
#define _H_Figure

#include <iostream>
#include "Clonable.h"

namespace mas {

class Canvas;
class Point;
class Line;

class Figure: public Clonable {
public:
  virtual ~Figure ();

  virtual Figure* Clone () const {throw "Figure::Clone is an abstract function";};

  virtual void Scale (double fx, double fy) = 0; // pre IsDeformable () || fx == fy
  virtual void Translate (double dx, double dy) = 0;
  virtual void Rotate (double angle) = 0;  // pre IsRotatable ();

  virtual void RotateAround (double angle, const Point& p);
  virtual void RotateByDegrees (double degrees);
  virtual void RotateAroundByDegrees (double degrees, const Point& p);
  virtual void ScaleByPoint (const Point& p);
  virtual void ScaleUniformly (double f);
  virtual void TranslateByPoint (const Point& p);
  virtual void TranslateByPointReverse (const Point& p);
  virtual void Mirror (const Line& z);

  virtual bool IsRotatable () const;
  virtual bool IsDeformable () const;

  virtual void Draw (Canvas&) const {};
  virtual void Write (std::ostream& output = std::cout) const = 0;
  virtual void WriteLine (std::ostream& = std::cout) const;
  friend std::ostream& operator << (std::ostream& output, const Figure& f);
};

}

#endif
