#ifndef _H_LIFE
#define _H_LIFE

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include "Point.h"

class Life{
private:

public:
	std::map<mas::Point, int> Pontos;
	std::map<mas::Point, int> TEMP;
	std::set<mas::Point> vizinhos;

	int G;

	void READ(std::istream& input)
	{
		int N;
		input >> N;
		for(int i=0; i<N; i++)
		{
			mas::Point p;
			int x,y;
			input >> x >> y;
			p.Set(x, y);
			Pontos[p]++;
		}
		input >> G;
	}

	int COUNT_FULLVIZINHOS_FULL(mas::Point p)
	{
		int x = static_cast<int>(p.X());
		int y = static_cast<int>(p.Y());
		int count = 0;
		for(int xi=-1; xi<=1; xi++)
		{
			for(int yi=-1; yi<=1; yi++)
			{
				mas::Point t;
				t.Set(x+xi, y+yi);
				if(Pontos.find(t) != Pontos.end())
					count++;
			}
		}
		count--;
		return count;
	}

	int COUNT_EMPTYVIZINHOS_FULL(mas::Point p)
	{
		int x = static_cast<int>(p.X());
		int y = static_cast<int>(p.Y());
		int count = 0;
		for(int xi=-1; xi<=1; xi++)
		{
			for(int yi=-1; yi<=1; yi++)
			{
				mas::Point t;
				t.Set(x+xi, y+yi);
				if(Pontos.find(t) != Pontos.end())
					count++;
			}
		}
		return count;
	}

	void GET_EMPTYCASES()
	{
		for(std::map<mas::Point, int>::iterator j = Pontos.begin(); j!=Pontos.end(); j++)
		{

			int x_ = static_cast<int>((*j).first.X());
			int y_ = static_cast<int>((*j).first.Y());
			for(int i=-1; i<=1; i++)
			{
				for(int j=-1; j<=1; j++)
				{
					mas::Point t;
					t.Set(x_+i, y_+j);
					if(Pontos.find(t) == Pontos.end())
					{
						mas::Point t;
						t.Set(x_+i, y_+j);
						vizinhos.insert(t);
					}
				}
			}
		}
	}

	void CREATE_LIFE()
	{
		for(std::set<mas::Point>::iterator i= vizinhos.begin(); i!=vizinhos.end(); i++)
		{
			mas::Point t = (*i);
			int count_vizinhos = COUNT_EMPTYVIZINHOS_FULL(t);
			if(count_vizinhos == 3)
				TEMP[t]++;
		}
	}

	void CLEAN_LIFE()
	{
		for(std::map<mas::Point, int>::iterator j = Pontos.begin(); j!=Pontos.end(); j++)
		{
			mas::Point t = j->first;
			int a = COUNT_FULLVIZINHOS_FULL(t);
			if(a >= 2 && a <= 3)
				TEMP[t]++;
		}
	}

	void GENERATE()
	{
		READ(std::cin);
		for(int i=0; i<G; i++)
		{
			GET_EMPTYCASES();
			CLEAN_LIFE();
			CREATE_LIFE();
			Pontos = TEMP;
			TEMP.clear();
		}
		int numcelulas = static_cast<int>(Pontos.size());
		std::cout << numcelulas << std::endl;
		int count = 0;
		for(std::map<mas::Point, int>::iterator j = Pontos.begin(); j!=Pontos.end(); j++)
		{
			if(count == 32)
				break;
			std::cout << (*j).first.X() << " " << (*j).first.Y() << std::endl;
			count++;
		}
	}

};

#endif
