#ifndef _H_Particle
#define _H_Particle

namespace mas {

class Particle: public Point {
private:
  double mass_;
public:
  Particle ();
  Particle (double x, double y, double mass);
  Particle (const Particle& other);
  explicit Particle (const Point& other);

  virtual ~Particle();

  virtual double Energy () const;
  virtual void Energize (double energy);
  virtual double Mass () const;

  virtual double Force (const Particle& other) const;

  virtual void Write (std::ostream& output) const;

public:  // static consts
  static const double speedOfLight;
  static const double gravitational;
};

}

#endif
