#ifndef _H_Point
#define _H_Point

#include "Figure.h"
#include "Canvas.h"

namespace mas {

class Point: public Figure {
private:
  double x_;
  double y_;
public:
  Point ();
  Point (double x, double y);
  Point (const Point& other);
  virtual ~Point ();

  virtual Point* Clone() const;

  virtual bool Equal (const Point& other) const;
  virtual bool operator == (const Point& other) const;
  virtual bool operator != (const Point& other) const;
  virtual bool operator <= (const Point& other) const;
  virtual bool operator < (const Point& other) const;
  virtual bool operator >= (const Point& other) const;
  virtual bool operator > (const Point& other) const;

  virtual double X () const;
  virtual double Y () const;
  virtual void SetX (double x);
  virtual void SetY (double y);
  virtual void Set (double x, double y);
  virtual void Translate (double dx, double dy);
  virtual void Scale (double fx, double fy);
  virtual void Rotate (double angle);
  virtual double DistanceTo (const Point& other) const;

  virtual double Angle () const;
  virtual double Modulus () const;

  virtual void Draw (Canvas& x) const;
  virtual void Write (std::ostream& output = std::cout) const;
  virtual void Read (std::istream& input = std::cin);
};

}

#endif
