#include <vector>
#include <string>
#include <cstdlib>
#include <cerrno>

#include "Utilities_string.h"

namespace mas {

int AsInt (const std::string& s, int base)
{
  int  result;
  char *endp;
  errno = 0; 
  result = ::strtol(s.c_str(), &endp, base);
  if (s.empty() || errno || *endp)
  {
    errno = 0;
    std::string message ("\"" + s + "\" is not a legal int value.");
    throw message;
  }
  return result;
}

double AsDouble (const std::string& s)
{
  double  result;
  char *endp;
  errno = 0;
  result = ::strtod (s.c_str(), &endp);
  if (s.empty() || errno || *endp)
  {
    errno = 0;
    std::string message("\"" + s + "\" is not a legal double value.");
    throw message;
  }
  return result;
}

std::string AsString(int x, const char *fmt)
{
  char s[32];
  sprintf (s, fmt, x);
  return std::string(s);
}

std::string AsString(double x, const char *fmt)
{
  char s[255];
  sprintf (s, fmt, x);
  return std::string(s);
}

std::string Decimal(int x)
{
  return (x < 10 ? "" : Decimal(x / 10)) + static_cast<char>(x  % 10 + '0');
}

std::vector<std::string> GetTokens(const std::string& s, const std::string& delimiters)
{
  std::vector<std::string> result;
  std::string::size_type x = 0;
  while ((x = s.find_first_not_of (delimiters, x)) != std::string::npos)
  {
    std::string::size_type y = s.find_first_of (delimiters, x);
    result.push_back (s.substr(x, y - x));
    x = y;
  }
  return result;
}

}
